import os
from PIL import Image as PILImage
from IPython.display import display, Image

def p(option=None):
    task_map = {
        1: """import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as sts
import sympy as sp
import math
import warnings
import statsmodels.api as sm
warnings.filterwarnings('ignore')

data = pd.read_excel('C:\\Users\\Mikhail\\Downloads\\Пересдача по эконометрике.xlsx', sheet_name='Вариант 1', skiprows=[1], usecols='A:B')
data.head()

plt.figure(figsize=(15, 10))

plt.plot(data['T'], data['EMPLDEC_Y'])

plt.title('График исходного ряда')
plt.xlabel('T')
plt.ylabel('EMPLDEC_Y')
plt.grid()

plt.show()

----------------------------------------------

По исходному ряду можно сказать о наличии тренда и сделать вывод о будущем росте
заявленной потребности в рабочих. Сезоннность в ряде не наблюдается,
но присутствуют реские всплески в 2008, 2014, 2021 годах.
Можно сделать предположение о том, что это связанно
с кризисным мировым положением. Экономический кризис
в начале второго десятка 21 века, кризисная ситуация
в 14 и 21 году в западной Европе.
А также можно сказать о росте в 2018 - 2020 годах свзанных с пандемией


По исходному ряду можно сказать о наличии тренда и сделать вывод о будущем росте заявленной потребности в рабочих. Сезоннность в ряде не наблюдается, но присутствуют реские всплески в 2008, 2014, 2021 годах. Можно сделать предположение о том, что это связанно с кризисным мировым положением. Экономический кризис в начале второго десятка 21 века, кризисная ситуация в 14 и 21 году 
в западной Европе. А также можно сказать о росте в 2018 - 2020 годах свзанных с пандемией

----------------------------------------------

y1, y2 = np.array_split(data['EMPLDEC_Y'], 2)
n1, n2 = y1.shape[0], y2.shape[0]

y1_mean, y2_mean = y1.mean(), y2.mean()
sigma_1, sigma_2 = y1.var(), y2.var()

F = sigma_1/sigma_2
F_crit = sts.f(n1-1, n2-1).isf(0.05)

print('Гипотеза принимается') if F < F_crit else print('Гипотеза отвергается')


sigma = np.sqrt(((n1 - 1) * sigma_1 + (n2 - 1) * sigma_2)/(n1 + n2 - 2))
t = abs(y1_mean - y2_mean)/(sigma * np.sqrt(1/n1 + 1/n2))
t_crit = sts.t(n1 + n2 - 2).isf(0.05/2)

print('Тренд отсутствует') if t < t_crit else print('Тренд присутствует')

----------------------------------------------

3. Провести проверку наличия тренда с помощью метода Фостера-Стьюарта. Сравнить выводы двух тестов. (9 баллов)

----------------------------------------------

kt = []
lt = []

for i in range(1, len(data['EMPLDEC_Y'])):
    kt.append(int(data['EMPLDEC_Y'][i] > data['EMPLDEC_Y'][:i].max()))
    lt.append(int(data['EMPLDEC_Y'][i] < data['EMPLDEC_Y'][:i].min()))
    
s = sum(kt) + sum(lt)
d = sum(kt) - sum(lt)

sigma_1 = np.sqrt(2*np.log(data.shape[0]) - 3.4253)
sigma_2 = np.sqrt(2*np.log(data.shape[0]) - 0.8456)

mu = (1.693872*np.log(data.shape[0]) - 0.299015)/(1 - 0.035092*np.log(data.shape[0]) + 0.002705 * data.shape[0])

ts = abs(s - mu)/sigma_1
td = abs(s - 0)/sigma_2


t_crit = sts.t(data.shape[0]-1).isf(0.05/2)

print('Тренд ряда присутствует') if ts > t_crit else print('Тренд ряда отсутствует')

print('Тренд дисперсии присутствует') if td > t_crit else print('Тренд дисперсии отсутствует')

----------------------------------------------

Оба теста показывают наличие тренда.

----------------------------------------------

4. Провести прогнозирование с помощью кривой роста. Рассчитать точечный и интервальный прогноз на 4 периода вперед. (7 баллов)

Y = data['EMPLDEC_Y'].rolling(window=3).mean().dropna().reset_index(drop=True)

delta_y = ((Y.shift(1) - Y.shift(-1))/2).dropna()
delta_2y = ((delta_y.shift(1) - delta_y.shift(-1))/2).dropna()
exp = delta_y/Y.dropna()
ln = np.log(delta_y)
gp = np.log(exp)
lg = np.log(delta_y/Y**2).dropna()

plt.scatter(np.arange(1, len(exp)+1), exp)
plt.scatter(np.arange(1, len(ln)+1), ln)
plt.scatter(np.arange(1, len(gp)+1), gp)
plt.scatter(np.arange(1, len(lg)+1), lg)

data_train, data_test = data.iloc[:-4, :], data.iloc[-4:, :]

X = sm.add_constant(data['T'])
y = np.log(data['EMPLDEC_Y'])

model = sm.OLS(y, X).fit()

print(model.summary())

----------------------------------

X_forecast = np.arange(2022, 2026+1)
forecast = np.exp(model.predict(sm.add_constant(pd.Series(X_forecast))))

Se = np.sqrt(sum((data['EMPLDEC_Y'] - np.exp(model.predict(X)))**2)/(data.shape[0] - 1 - 1))
t = sts.t(data.shape[0] - 2).isf(0.05/2)

upper = []
lower = []

for i in range(len(forecast)):
  Sy = Se * np.sqrt(1 + 1/data.shape[0] + (X_forecast[i] - data['T'].mean())**2/
   (sum((data['T'] - data['T'].mean())**2)))
  U = Sy * t
  upper.append(forecast[i] + U)
  lower.append(forecast[i] - U)
upper = np.array(upper, dtype='float')
lower = np.array(lower, dtype='float')

----------------------------

plt.figure(figsize=(15, 10))
plt.plot(data['T'], data['EMPLDEC_Y'], label = 'Исходный ряд', color='blue')
plt.plot(data['T'], np.exp(model.predict(X)), label = 'Смоделированный ряд', color='green', linestyle='--')
plt.plot(data['T'][2:], Y, label='Сглаженный ряд', color='orange')
plt.plot(X_forecast, forecast, label = 'Предсказание', color='red', linestyle='--')
plt.fill_between(X_forecast, lower, upper, color='grey', alpha=0.6, label='Доверительный интервал')

plt.title('Прогнозирование с помощью кривой роста')
plt.legend(loc='upper left')
plt.grid()
plt.show()""",
        2: "Стьюдента, Ирвина, критерия на медиане, разности средних уровней, Фостера-Стьюарта, средневзвешенной скользящей средней, экспоненциальное сглаживание",
        3: "Системы",
        4: "Панельки, Фишера, Хаусмана, Бреуша-Пагана",
        5: "Логит, пробит",
        6.1: "ARIMA, ARMA",
        6.2: "AR(), MA(3)",
        6.3: "AR(1), MA(2), ARMA(2,3)"
    }

    if option is None:
        return ('1: (Предварительный анализ временных рядов)\n'
                '2: (Стьюдента, Ирвина, критерия на медиане, разности средних уровней, '
                'Фостера-Стьюарта, средневзвешенной скользящей средней, экспоненциальное сглаживание)\n'
                '3: (системы)\n'
                '4: (панельки, Фишера, Хаусмана, Бреуша-Пагана)\n'
                '5: (логит, пробит)\n'
                '6.1: (arima, arma)\n'
                '6.2: (ar(), ma(3))\n'
                '6.3: (ar(1), ma(2), arma(2,3))')
    else:
        return task_map.get(option, "Некорректная опция. Попробуйте снова.")

package_dir = os.path.dirname(__file__)
image_dir = os.path.join(package_dir, "images")

image_map = {
        1: ["001_1.png", "001_2.png"],
        2: ["002_1.png", "002_2.png"],
        3: ["003_1.png", "003_2.png"],
        4: ["004_1.png", "004_2.png"],
        5: ["005_1.png", "005_2.png", "005_3.png"],
        6: ["006_1.png", "006_2.png"],
        7: ["007_1.png", "007_2.png"],
        8: ["008_1.png", "008_2.png"],
        9: ["009_1.png", "009_2.png"],
        10: ["010_1.png", "010_2.png"],
        11: ["011_1.png"],
        12: ["012_1.png", "012_2.png"],
        13: ["013_1.png", "013_2.png"],
        14: ["014_1.png"],
        15: ["015_1.png"],
        16: ["016_1.png"],
        17: ["017_1.png", "017_2.png"],
        18: ["018_1.png"],
        19: ["019_1.png", "019_2.png"],
        20: ["020_1.png", "020_2.png", "020_3.png"],
        21: ["021_1.png"],
        22: ["022_1.png", "022_2.png", "022_3.png"],
        23: ["023_1.png", "023_2.png"],
        24: ["024_1.png", "024_2.png"],
        25: ["025_1.png"],
        26: ["026_1.png"],
        27: ["027_1.png"],
        28: ["028_1.png"],
        29: ["029_1.png"],
        30: ["030_1.png", "030_2.png"],
        31: ["031_1.png", "031_2.png", "031_3.png"],
        32: ["032_1.png", "032_2.png", "032_3.png"],
        33: ["033_1.png"],
        34: ["034_1.png", "034_2.png"],
        35: ["035_1.png", "035_2.png"],
        36: ["036_1.png", "036_2.png"],
        37: ["037_1.png", "037_2.png", "037_3.png", "037_4.png"],
        38: ["038_1.png"],
        39: ["039_1.png", "039_2.png"],
        40: ["040_1.png", "040_2.png", "040_3.png"],
        41: ["041_1.png"],
        42: ["042_1.png"],
        43: ["043_1.png"],
        44: ["044_1.png", "044_2.png"],
        45: ["045_1.png"],
        46: ["046_1.png", "046_2.png"],
        47: ["047_1.png"],
        48: ["048_1.png", "048_2.png"],
        49: ["049_1.png", "049_2.png"],
        50: ["050_1.png", "050_2.png"],
        51: ["051_1.png", "051_2.png"],
        52: ["052_1.png", "052_2.png", "052_3.png"],
        53: ["053_1.png", "053_2.png"],
        54: ["054_1.png", "054_2.png"],
        55: ["055_1.png"],
        56: ["056_1.png", "056_2.png", "056_3.png"],
        57: ["057_1.png", "057_2.png", "057_3.png"],
        58: ["058_1.png"],
        59: ["059_1.png"],
        60: ["060_1.png", "060_2.png"],
        61: ["061_1.png"],
        62: ["062_1.png", "062_2.png"],
        63: ["063_1.png", "063_2.png", "063_3.png", "063_4.png"],
        64: ["064_1.png", "064_2.png"],
        65: ["065_1.png"],
        66: ["066_1.png"],
        67: ["067_1.png", "067_2.png"],
        68: ["068_1.png", "068_2.png"],
        69: ["069_1.png", "069_2.png", "069_3.png"],
        70: ["070_1.png", "070_2.png", "070_3.png"],
        71: ["071_1.png"],
        72: ["072_1.png", "072_2.png"],
        73: ["073_1.png", "073_2.png"],
        74: ["074_1.png", "074_2.png"],
        75: ["075_1.png", "075_2.png"],
        76: ["076_1.png", "076_2.png"],
        77: ["077_1.png", "077_2.png"],
        78: ["078_1.png", "078_2.png"],
        79: ["079_1.png"],
        80: ["080_1.png", "080_2.png"],
        81: ["081_1.png"],
        82: ["082_1.png", "082_2.png"],
        83: ["083_1.png", "083_2.png", "083_3.png", "083_4.png", "083_5.png"],
        84: ["084_1.png", "084_2.png"],
        85: ["085_1.png", "085_2.png"],
        86: ["086_1.png", "086_2.png"],
        87: ["087_1.png", "087_2.png", "087_3.png"],
        88: ["088_1.png", "088_2.png"],
        89: ["089_1.png", "089_2.png", "089_3.png"],
        90: ["090_1.png", "090_2.png"],
        91: ["091_1.png"],
        92: ["092_1.png", "092_2.png"],
        93: ["093_1.png", "093_2.png"],
        94: ["094_1.png"],
        95: ["095_1.png", "095_2.png"],
        96: ["096_1.png", "096_2.png", "096_3.png"],
        97: ["097_1.png", "097_2.png"],
        98: ["098_1.png", "098_2.png"],
        99: ["099_1.png", "099_2.png", "099_3.png"],
        100: ["100_1.png"],
        101: ["101_1.png"],
        102: ["102_1.png"],
        103: ["103_1.png", "103_2.png"],
        104: ["104_1.png", "104_2.png", "104_3.png", "104_4.png"],
        105: ["105_1.png", "105_2.png"],
        106: ["106_1.png"],
        107: ["107_1.png"],
        108: ["108_1.png"],
        109: ["109_1.png", "109_2.png"],
        110: ["110_1.png"],
        111: ["111_1.png"],
        112: ["112_1.png", "112_2.png", "112_3.png"],
        113: ["113_1.png", "113_2.png"],
        114: ["114_1.png", "114_2.png", "114_3.png"],
        115: ["115_1.png", "115_2.png", "115_3.png"],
        116: ["116_1.png"],
        117: ["117_1.png"],
        118: ["118_1.png"],
        119: ["119_1.png"],
        120: ["120_1.png", "120_2.png", "120_3.png", "120_4.png"],
        121: ["121_1.png", "121_2.png"]
    }


def t(option=None):
    if option is None:
        return ("""1. Линейная модель множественной регрессии. Основные предпосылки метода наименьших квадратов.
2. Нелинейные модели регрессии. Подходы к оцениванию. Примеры
3. Тестирование правильности выбора спецификации: типичные ошибки спецификации модели, Тест Рамсея (тест RESET), условия применения теста.
4. Тестирование правильности выбора спецификации: типичные ошибки спецификации модели, Критерий Акаике, Критерий Шварца. условия применения критериев.
5. Гетероскедастичность: определение, причины, последствия. Тест Голдфеда-Квандта и особенности его применения.
6. Гетероскедастичность: определение, причины, последствия. Тест ранговой корреляции Спирмена и особенности его применения.
7. Гетероскедастичность: определение, причины, последствия. Тест Бреуша-Пагана и особенности его применения.
8. Гетероскедастичность: определение, причины, последствия. Тест Глейзера и особенности его применения.
9. Способы корректировки гетероскедастичности: взвешенный метод наименьших квадратов (ВМНК) и особенности его применения.
10. Автокорреляция: определение, причины, последствия. Тест Дарбина-Уотсона и особенности его применения.
11. Автокорреляция: определение, причины, последствия. Тест Бройша – Годфри и особенности его применения.
12. Автокорреляция: определение, причины, последствия. H – тест и особенности его применения.
13. Автокорреляция: определение, причины, последствия. Метод рядов Сведа-Эйзенхарта и особенности его применения.
14. Модель с автокорреляцией случайного возмущения. Оценка моделей с авторегрессией.
15. Процедура Кохрейна-Оркатта.
16. Процедура Хилдрета – Лу.
17. Оценка влияния факторов, включенных в модель. Коэффициент эластичности, Бета-коэффициент, Дельта – коэффициент.
18. Мультиколлинеарность: понятие, причины и последствия.
19. Алгоритм пошаговой регрессии.
20. Метод главных компонент (PCA) как радикальный метод борьбы с мультиколлинеарностью
21. Выявление мультиколлинеарности: коэффициент увеличения дисперсии (VIF –тест).
22. Выявление мультиколлинеарности: Алгоритм Фаррара-Глобера.
23. Построение гребневой регрессии. Суть регуляризации.
24. Фиктивная переменная и правило её использования.
25. Модель дисперсионного анализа.
26. Модель ковариационного анализа.
27. Фиктивные переменные в сезонном анализе.
28. Фиктивная переменная сдвига: спецификация регрессионной модели с фиктивной переменной сдвига; экономический смысл параметра при фиктивной переменной; смысл названия.
29. Фиктивная переменная наклона: спецификация регрессионной модели с фиктивной переменной наклона; экономический смысл параметра при фиктивной переменной; смысл названия.
30. Определение структурных изменений в экономике: использование фиктивных переменных, тест Чоу.
31. Модели бинарного выбора. Недостатки линейной модели.
32. Модели множественного выбора: модели с неупорядоченными альтернативными вариантами.
33. Модели усеченных выборок.
34. Модели цензурированных выборок (tobit-модель).
35. Модели множественного выбора: гнездовые logit-модели.
36. Модели счетных данных (отрицательная биномиальная модель, hurdle-model)
37. Модели множественного выбора: модели с упорядоченными альтернативными вариантами.
38. Модели случайно усеченных выборок (selection model).
39. Логит-модель. Этапы оценки. Области применения.
40. Пробит-модель. Этапы оценки. Области применения.
41. Метод максимального правдоподобия
42. Свойства оценок метода максимального правдоподобия.
43. Информационная матрица и оценки стандартных ошибок для оценок параметров logit и probit моделей. Интерпретация коэффициентов в моделях бинарного выбора.
44. Мера качества аппроксимации и качества прогноза logit и probit моделей.
45. Временные ряды: определение, классификация, цель и задача моделирования временного ряда.
46. Исследование структуры одномерного временного ряда.
47. Процедура выявления аномальных наблюдений на основе метода Ирвина. Особенности применения метода. Анализ аномальных наблюдений.
48. Проверка наличия тренда. Критерий серий, основанный на медиане. Особенности применения метода.
49. Процедура выявления аномальных наблюдений. Причины аномальных значений. Блочные диаграммы по типу «ящика с усами».
50. Проверка наличия тренда. Метод проверки разности средних уровней. Особенности применения метода.
51. Проверка наличия тренда. Метод Фостера-Стьюарта. Особенности применения метода.
52. Сглаживание временных рядов. Простая (среднеарифметическая) скользящая средняя. Взвешенная (средневзвешенная) скользящая средняя. Среднехронологическая. Экспоненциальное сглаживание.
53. Функциональные зависимости временного ряда. Предварительный анализ временных рядов.
54. Трендовые модели. Без предела роста. Примеры функций. Содержательная интерпретация параметров.
55. Процедура выявления аномальных наблюдений на основе распределения Стьюдента. Особенности применения метода. Анализ аномальных наблюдений.
56. Трендовые модели. С пределом роста без точки перегиба. Примеры функций. Содержательная интерпретация параметров.
57. Трендовые модели. С пределом роста и точкой перегиба или кривые насыщения. Примеры функций. Содержательная интерпретация параметров.
58. Выбор кривой роста.
59. Прогнозирование с помощью кривой роста.
60. Прогнозирование временного ряда на основе трендовой модели.
61. Модель Тейла-Вейджа (мультипликативная модель).
62. Метод Четверикова.
63. Моделирование тренд-сезонных процессов. Типы функциональных зависимостей.
64. Мультипликативная (аддитивная) модель ряда динамики при наличии тенденции: этапы построения.
65. Моделирование периодических колебаний (гармоники Фурье).
66. Прогнозирование одномерного временного ряда случайной компоненты (распределение Пуассона).
67. Функциональные преобразования переменных в линейной регрессионной модели. Метод Зарембки. Особенности применения.
68. Функциональные преобразования переменных в линейной регрессионной модели. Тест Бокса-Кокса. Особенности применения.
69. Адаптивная модель прогнозирования Брауна.
70. Функциональные преобразования переменных в линейной регрессионной модели. Критерий Акаике  и Шварца. Особенности применения.
71. Модель Хольта-Уинтерса (адаптивная модель).
72. Функциональные преобразования переменных в линейной регрессионной модели. Тест Бера. Особенности применения.
73. Функциональные преобразования переменных в линейной регрессионной модели. Тест МакАлера. Особенности применения.
74. Функциональные преобразования переменных в линейной регрессионной модели. Тест МакКиннона. Особенности применения.
75. Функциональные преобразования переменных в линейной регрессионной модели. Тест Уайта. Особенности применения.
76. Функциональные преобразования переменных в линейной регрессионной модели. Тест Дэвидсона. Особенности применения.
77. Модели с распределенными лаговыми переменными.
78. Оценка моделей с лагами в независимых переменных. Преобразование Койка
79. Полиномиально распределенные лаги Алмон
80. Авторегрессионные модели.
81. Авторегрессионные модели с распределенными лагами.
82. Стационарные временные ряды. Определения стационарности, лаговой переменной, автоковариационной функции временного ряда, автокоррляционной функции, коррелограммы,  коэффициенты корреляции между разными элементами стационарного временного ряда с временным лагом.
83. Стационарные временные ряды. Определения частной автокорреляционной функции, белого шума, автоковариационная функция для белого шума, ACF для белого шума, частная автокорреляционная функция для белого шума.
84. Модели стационарных временных рядов: модель ARMA(p,q) (классический вид и через лаговый оператор). Авторегрессионный многочлен, авторегрессионная часть и часть скользящего среднего.
85. Модели стационарных временных рядов: модель ARMA(1, q). Доказательство утверждения: Модель ARMA(1, q) стационарна тогда и только тогда, когда |a|<1.
86. Модели стационарных временных рядов: Модель MA(q), Среднее, дисперсия и ACF для MA(q). Модель MA(∞).
87.  Модели стационарных временных рядов: Модель AR(p). Доказательство утверждения: Модель AR(p) определяет стационарный ряд ⇐⇒ выполнено условие стационарности: все корни многочлена a(z) по модулю больше единицы. Модель AR(1).
88. Прогнозирование для модели ARMA. Условия прогнозирования. Периоды прогнозирования. Информативность прогнозов.
89. Оценка и тестирование модели: Предварительное тестирование на белый шум.
90. Оценка модели и тестирование гипотез временного ряда.
91. Информационные критерии для сравнения моделей и выбора порядка временного ряда: Акаике, Шварца, Хеннана-Куина. Условия их применения.
92. Проверка адекватности модели: тесты на автокорреляцию временного ряда Дарбина-Уотсона, Льюинга-Бокса.
93. Линейная регрессия для стационарных рядов: Модель FDL.
94. Линейная регрессия для стационарных рядов. Модель ADL.
95. Понятие TS-ряда. Модель линейного тренда. Модель экспоненциального тренда.
96. Нестационарные временные ряды: случайное блуждание, стохастический тренд, случайное блуждание со сносом.
97. Дифференцирование ряда: определение, DS-ряды.
98. Подход Бокса-Дженкинса.
99. Модель ARIMA.
100. Тест ADF на единичный корень.
101. Модель ARCH.
102. Модель GARCH.
103. Область применения панельных данных. Преимущества использования панельных данных.
104. Модели панельных данных и основные обозначения.
105. Модель пула (Pool model).
106. Модель регрессии с фиксированным эффектом (fixed effect model)
107. Модель регрессии со случайным эффектом (random effect model).
108. Тест Бройша-Пагана для панельных данных
109. Тест Хаусмана для панельных данных.
110. Тест Лагранжа для панельных данных.
111. Вычисление значения оценок параметров β и а в модели с фиксированным эффектом.
112. Отражение пространственных эффектов. Бинарная матрица граничных соседей. Приведите пример.
113. Отражение пространственных эффектов. Бинарная матрица ближайших соседей. Приведите пример.
114. Отражение пространственных эффектов. Матрица расстояний. Приведите пример.
115. Отражение пространственных эффектов. Матрица расстояний с учетом размера объекта. Приведите пример.
117. Пространственная автокорреляция по методологии А. Гетиса и Дж. Орда. Недостатки методологии.
118. Пространственная автокорреляция по методологии Роберта Джири.
119. Пространственная автокорреляция по методологии Морана П.
120. Пространственная кластеризация территорий. Локальный индекс автокорреляции П. Морана (Ili)
121. Матрица взаимовлияния Л. Анселина (LISA).""")



    else:

            try:

                    # Получаем список путей к изображениям для задачи

                    image_paths = image_map.get(option)

                    if image_paths:

                            # Выводим каждое изображение в ячейке Jupyter Notebook

                            for image_path in image_paths:
                                    # Отображаем изображение в Jupyter Notebook

                                    display(Image(filename=image_path))

                            return f"Показаны изображения для задачи {option}."

                    else:

                            return "Изображения для данной задачи не найдены."

            except ValueError:

                    return "Некорректная опция. Попробуйте снова."
